<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: robot.php,v 1.18 2003/06/10 12:38:11 adam Exp $
require("config.php");
require("standards.php");

find_portal_root();

if (!$url) {
   $url = "";
   $singleURL = 0;
}

//echo "<pre>";
//print_r($_SERVER);
//echo "</pre>";
/*Turns debugging mode on.*/
$debug = 0;

/*The filename of the file containing the URLs that have been tested bad. */
$badfilename = $_SERVER['DOCUMENT_ROOT']."/$cwd/badurls.tkl";
$badarray = basename (strval($badfilename),".tkl");
$badnr = 0;
$myarray = array();

/*The filename of the file containing the URLs to be tested. */
$checkfilename = $_SERVER['DOCUMENT_ROOT']."/$cwd/urls.tkl";
$checkarray = basename (strval($checkfilename),".tkl");

function startElement($parser, $name, $attribs) {
    global $debug, $currentArrayName, $tagName, $i;
    $tagName = $name;
    if ($debug) {
        print "&lt;<font color=\"#0000cc\">$name</font>";
    }
    if (sizeof($attribs)) {
        while (list($k, $v) = each($attribs)) {
            if ($debug) {
                print " <font color=\"#009900\">$k</font>=\"<font color=\"#990000\">$v</font>\"";
            }
            $GLOBALS[$currentArrayName][$name][$k] = $v;
        }
    }
    if ($debug) {
        print "&gt;";
    }
    if ($name == "BADURL" || $name == "CHECKURL") {
        $i++;
    }
}

function endElement($parser, $name) {
    global $debug;
    if ($debug) {
        print "&lt;/<font color=\"#0000cc\">$name</font>&gt;";
    }
}

function characterData($parser, $data) {
    global $debug, $currentArrayName, $tagName, $i, $oldi, $olddata, $myarray;
    if (!$oldi) {
        $oldi = $i;
    }
    if ($debug) {
        print "<b>$data</b>";
    }
    if (trim($data) != "") {
        $GLOBALS[$currentArrayName][$i][$tagName] .= $data;
    }
}

function defaultHandler($parser, $data) {
    global $debug;
    if (substr($data, 0, 1) == "&" && substr($data, -1, 1) == ";") {
        if ($debug) {
            printf('<font color="#aa00aa">%s</font>',
                htmlspecialchars($data));
        }
    } else {
        if ($debug) {
            printf('<font size="-1">%s</font>',
                htmlspecialchars($data));
        }
    }
}

function new_xml_parser($filename) {
    global $parser_file;

    $xml_parser = xml_parser_create();
    xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, 1);
    xml_set_element_handler($xml_parser, "startElement", "endElement");
    xml_set_character_data_handler($xml_parser, "characterData");
    xml_set_processing_instruction_handler($xml_parser, "PIHandler");
    xml_set_default_handler($xml_parser, "defaultHandler");

    if (!($fp = @fopen($filename, "r"))) {
        return false;
    }
    if (!is_array($parser_file)) {
        settype($parser_file, "array");
    }
    $parser_file[$xml_parser] = $filename;
    return array($xml_parser, $fp);
}

function readXML($filename) {
    global $debug, $currentArrayName, $i, $badarray, $$badarray, $myarray;
    $i = -1;
    $currentArrayName = basename (strval($filename),".tkl");
    global $$currentArrayName;
    if ($debug) {
        print "<pre>";
    }
    if (!(list($xml_parser, $fp) = new_xml_parser($filename))) {
        die("Kunne ikke bne XML fil $filename");
    }
    while ($data = fread($fp, 4096)) {
        if (!xml_parse($xml_parser, $data, feof($fp))) {
            die(sprintf("XML error: %s at line %d\n",
                        xml_error_string(xml_get_error_code($xml_parser)),
                        xml_get_current_line_number($xml_parser)));
        }
    }
    if ($debug) {
        print "</pre>";
        print "Parse complete<p>\n";
        echo "<br><pre>$currentArrayName: \n";
        print_r($$currentArrayName);
        echo "</pre>\n";
    }
}

function writeXML() {
    global $badfilename, $badarrayNew, $robotErrorNr;
    reset($badarrayNew);
    $fileid = fopen($badfilename, "w+");
    fputs ($fileid, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fputs ($fileid, "<badurls>\n");
    foreach ($badarrayNew as $bad) {
        if ($bad != "") {
            fputs ($fileid, "  <BADURL>\n");
            fputs ($fileid, "    <URL>".escape_amp($bad['URL'])."</URL>\n");
            fputs ($fileid, "    <FILENAME>".$bad['FILENAME']."</FILENAME>\n");
            fputs ($fileid, "    <ERRORCODE>".escape_amp($bad['ERRORCODE'])."e</ERRORCODE>\n");
            fputs ($fileid, "    <CHECKEDNUMBER>".$bad['CHECKEDNUMBER']."</CHECKEDNUMBER>\n");
            fputs ($fileid, "    <CHECKEDLAST>".$bad['CHECKEDLAST']."</CHECKEDLAST>\n");
            fputs ($fileid, "  </BADURL>\n");
            if ($bad['CHECKEDNUMBER'] >= $robotErrorNr) {
                sendEmail($bad);
            }
        }
    }
    fputs ($fileid, "</badurls>\n");
    fclose($fileid);
}

function sendEmail($bad) {
    global $checkfilename, $portalName, $cwd, $_SERVER, $urlchecker_admin, $robot_admin_email;
    if ($bad['USER']) {
        $user_info = get_user_info($bad['USER']);
        if (!is_array($user_info)) {
            echo "Ingen brugeroplysninger for ".$bad['USER']."<br>\n";
            return "";
        } elseif (!$user_info["email"]) {
            echo "Ingen email adresse for ".$bad['USER']."<br>\n";
            return "";
        }
        $path = dirname($_SERVER['SCRIPT_NAME']);
        $tekst = "Denne mail er automatisk genereret af ".$portalName."s URL check system.\n
Din post \"".get_title($bad['FILENAME'])."\" er nu blevet checket ".$bad['CHECKEDNUMBER']." gange, sidste gang ".$bad['CHECKEDLAST'].", og har
hver gang returneret fejlen: ".$bad['ERRORCODE'].".\n
Du kan se siden her: ".$bad['URL']."\n
Posten kan rettes her: http://".$_SERVER['HTTP_HOST'].$path."/xform.php?xml_file=".$bad['FILENAME'];
        mail($user_info["email"], "En af dine poster trnger til opdatering", $tekst, "From: $robot_admin_email");
        echo "Mail sendt til ".$user_info["name"]." (".$user_info["email"].")<br>\n";
    } else {
        echo "Intet brugernavn i $checkfilename<br>\n";
    }
}

function makeSingleURLStuff($url) {
    global $checkarray, $badarray, $singleURL;
    $GLOBALS[$checkarray][0]['URL'] = $url;
    $GLOBALS[$badarray][0]['URL'] = "";
    $singleURL = 1;
}


if ($url == "" && is_file($badfilename)) {
    readXML($badfilename);
} else {
    $arrayname = basename (strval($badfilename),".tkl");
    $$arrayname = array();
}

if ($url != "") {
    makeSingleURLStuff($url);
} elseif ($checkfilename) {
    readXML($checkfilename);
}


reset($$checkarray);
//$URLarray = parse_url("http://www.hw.ac.uk/libWWW/irn/pinakes/pinakes.html");
/*This is the main URL check loop. */
foreach ($$checkarray as $page) {
    reset($$badarray);
    $outarray = "";
    $errorcode == "";
    $URLarray = parse_url($page['URL']);
    if (!array_key_exists("port", $URLarray)) {
        $URLarray['port'] = "80";
    }
    if (!array_key_exists("path", $URLarray) || trim($URLarray['path']) == "") {
        $URLarray['path'] = "/";
    }
    if (!array_key_exists("query", $URLarray)) {
        $URLarray['query'] = "";
    } else {
        $URLarray['query'] = "?".$URLarray['query'];
    }
    /* Get the port for the WWW service. */
    $service_port = getservbyname ('www', 'tcp');

    /* Get the IP address for the target host. */
    $address = gethostbyname ($URLarray['host']);

    /* Create a TCP/IP socket. */
    $socket = @socket_create (AF_INET, SOCK_STREAM, 0);

    if ($socket < 0) {
        if ($debug) {
            echo "socket_create() failed: reason: " . socket_strerror ($socket) . "\n";
        }
    } else {
        if ($debug) {
            echo "OK.\n";
        }
    }

    if ($debug) {
        echo "Attempting to connect to '$address' on port '".$URLarray['port']."'...";
    }
    socket_set_nonblock($socket);
    $result = @socket_connect ($socket, $address, $URLarray['port']);
    $result = TRUE;
    if ($result == FALSE) {
        if ($debug) {
            echo "socket_connect() failed.\nReason: ($result) " . socket_strerror($result) . "\n";
        }
        $errorcode = 999;
        $errorstring = "999 Serveren findes ikke eller porten er angivet forkert";
    } else {
        if ($debug) {
            echo "OK.\n";
        }
    }
    if (PHP_VERSION == "4.1.2") {
	$read = socket_fd_alloc();
	$write = socket_fd_alloc();
	socket_fd_set($read,$socket);
	socket_fd_set($write,$socket);
    } else {
    	$read = array();
    	$write = array();
    	array_push($read,$socket);
    	array_push($write,$socket);
    }
    $socket_ret = socket_select($read,$write,$except=NULL, $robotTimeout);
    if ($socket_ret <= 0) {
        $result = FALSE;
    } else {
        $result = TRUE;
    }
    flush();
    if ($result != FALSE) {
        /*Create the header*/
        $header = "Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*\n";
        $header .= "Accept-Encoding: gzip, deflate\n";
        $header .= "Accept-Language: da\n";
        $header .= "Connection: Keep-Alive\n";
        $header .= "Host: ".$URLarray['host']."\n";
        $header .= "User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0; T312461)\n";
        $header .= "\n"; //These newlines are important

        $in = "GET ".$URLarray['path'].$URLarray['query']." HTTP/1.0\n";
        $inString = $in.$header;

        if ($debug) {
            echo "<br>Sending HTTP HEAD request:<br><pre>".$in.$header."</pre>";
        }
        /*Sending the header request. */
        while (strlen($inString) > 0) {
            if (PHP_VERSION == "4.1.2") {
                $write = socket_fd_alloc();
                socket_fd_set($write,$socket);
            } else {
            	$write = array();
            	array_push($write,$socket);
            }
            $socket_ret = socket_select($read=NULL,$write,$except=NULL, $robotTimeout);
    	    if ($socket_ret <= 0) {
    	        break;
            }
            $inbytes = @socket_write ($socket, $inString, strlen ($inString));
    	    if ($inbytes == "") {
    	        break;
            }
            $inString = substr($inString, $inbytes);
        }
//        socket_write ($socket, $in.$header, strlen ($in));
        if ($debug) {
            echo "OK.<br>\n";
        }
        if ($debug) {
            echo "Reading response:\n\n";
        }
        /* Reciving the header request. */
    	$out = "";
    	while (strlen($out) < 2048) {
            if (PHP_VERSION == "4.1.2") {
                $read = socket_fd_alloc();
                socket_fd_set($read,$socket);
            } else {
                $read = array();
            	array_push($read,$socket);
            }
            $socket_ret = socket_select($read,$write=NULL,$except=NULL, $robotTimeout);
    	    if ($socket_ret <= 0) {
    	        $out = "";
    	        break;
            }
            $outbytes = @socket_read ($socket, 2048);
    	    if ($outbytes == "") {
    	        break;
            }
            $out = $out . $outbytes;
        }
        if ($debug) {
            echo "<pre>".htmlentities($out)."</pre>";
        }
        if ($out == "") {
            $errorcode = 999;
            $errorstring = "999 Serveren findes ikke eller porten er angivet forkert";
        } else {
            $outarray = explode("\n",$out);
            $firstline = $outarray[0];
            $errorstring = trim(substr($firstline, 9));
            $errorstringarray = explode(" ",$errorstring);
            $errorcode = $errorstringarray[0];
            if ($errorcode == "200" && $metadata) {
                $metadataArray = get_metadata($page['URL']);
            }
        }
    }
    $j = -1;
    $badkey = -1;
    foreach ($$badarray as $badpage) {
        $j++;
        if ($badpage != "") {
            if (array_search($page['URL'],$badpage)) {
                $badkey = $j;
            }
        }
    }
    if ($errorcode == 200) {
        print "URL: ".$page['URL']."<br>\n";
        flush();
        if ($singleURL) {
            echo "<b>URLen er OK.</b>";
        }
        if ($badkey != -1) {
           $GLOBALS[$badarray][$badkey] = "";
        }
    } else {
        print "URL: ".$page['URL']."<br>\n";
        print "Errorcode: $errorcode<p>\n";
        flush();
        if ($singleURL) {
            echo "<font color=\"red\"><b>URLen er IKKE OK. Fejlmeddelelse: $errorstring.</b></font>";
        } else {
            if ($badkey != -1) {
                $badarrayNew[$badnr]['CHECKEDNUMBER'] = $GLOBALS[$badarray][$badkey]['CHECKEDNUMBER'] + 1;
            } else {
                $badarrayNew[$badnr]['CHECKEDNUMBER'] = 1;
            }
            $badarrayNew[$badnr]['URL'] = $page['URL'];
            $badarrayNew[$badnr]['FILENAME'] = $page['FILENAME'];
            $badarrayNew[$badnr]['ERRORCODE'] = $errorstring;
            $badarrayNew[$badnr]['CHECKEDLAST'] = date("Y-m-d",time());
            $badarrayNew[$badnr]['USER'] = $page['USER'];
            $badnr++;
        }
    }
    if ($result != FALSE) {
        if ($debug) {
            echo "Closing socket...<br>";
        }
        socket_close ($socket);
        if ($debug) {
            echo "OK.<br>\n\n";
        }
    }
}

if ($debug) {
        print "</pre>";
        echo "<br><pre>$badarray: \n";
        print_r($$badarray);
        echo "</pre>\n";
    }

if (!$singleURL) {
    writeXML();
}

?>
