<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: handle_call.php,v 1.3 2003/06/10 12:38:11 adam Exp $

require "config.php";
require "standards.php";
require "search.php";

find_portal_root();
$this_user = check_auth_user();

$success = "";

if ($close_win) {
    echo <<<END
<html>
  <head>
    <script language="JavaScript">
        <!--- Comment to stop JavaScript from being read by unfriendly browers
	function close_refresh () {
	    opener.location.reload();
	    close();
	}
    </script>
  </head>
  <body onLoad="close_refresh()">
  </body>
</html>
END;
}

if (isset($remove)) {
    if (is_granted($remove, "write")) {
	get_links($_SERVER['DOCUMENT_ROOT'] . "/$doc_root", $all_links = array());
	echo "<pre>";
	print_r($all_links);
	echo "</pre>";
	if (is_array($links = $all_links[$remove])) {
	    $new_master = array_shift($links);		// Grab the first link and make it a real record file...
	    system("rm -f $new_master");
	    echo "COMMAND: 'cp $remove $new_master'<br>";
	    system("cp $remove $new_master");
	    foreach ($links as $link) {
		system("rm -f $link");
		if (!my_symlink($new_master, $link)) {
		    exception("Kunne ikke ndre eksistererende link <em>$link</em> til <em>$new_master</em>");
		    die;
		}
	    }
	}
	system("rm -f $remove");
    }
    if (!$close_win) {
	header("Location: $admin_script?" . makeparms($context));
    }
} elseif (isset($make_link_dir)) {
    $abs_file = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$make_link_dir/$make_link_file";
    if (is_granted($abs_file, "write")) {
	if (!my_symlink("$abs_cwd/$make_link_file", $abs_file)) {
	    exception("Kunne ikke oprette linket <b>$abs_cwd/$make_link_file</b>");
	    die;
	}
    } else {
	echo "<b>Du har ikke lov til at oprette links i dette katalog</b>";
	die;		// Make some fancy java-script woodoo to show this message...
    }
    if (!$close_win) {
	header("Location: $admin_script?" . makeparms($context));
    }
} elseif (isset($move_file)) {
    $abs_file = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$move_file_dir$move_file";
    //$abs_file = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$move_file_dir/$move_file";
    $orig_file = "$abs_cwd/$move_file";
    if (is_granted($orig_file, "write") && is_granted($abs_file, "write")) {
	system("cp $orig_file $abs_file");
	update_links($orig_file, $abs_file);
	system("rm $orig_file");
    } else {
	echo "<b>Du har ikke lov til at flytte filen</b>";
	die;		// make some java-script woodoo to show this message...
    }
    if (!$close_win) {
	header("Location: $admin_script?" . makeparms($context));
    }
} elseif ($action == "directory") {
    if (strlen($new_dir)) {
	if (strlen($new_dir)) {
	    $new_dir = preg_replace("/^\s+/", "", $new_dir);
	    $new_dir = preg_replace("/\s+$/", "", $new_dir);
	}
	if (!strlen($new_dir)) {
	    $error = 1;
	} elseif (file_exists("$abs_cwd/$new_dir")) {
	    $error = 2;
	} elseif (preg_match("/([\/|\.])/", $new_dir, $match)) {
	    $new_err = 3;
	} elseif (!mkdir("$abs_cwd/$new_dir", 0755)) {
	    $new_err = 4;
	}
	if ($auto_index = get_auto_index()) {
	    if (!file_exists($pop_up = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$xsd_path/$auto_index")) {
		$pop_up = "$xsd_path/$auto_index";
	    }
	    $index_candidate = "$abs_cwd/$new_dir/index.tkl";
	    if (!file_exists($index_candidate)) {
		$pop_up_write = $index_candidate;
	    }
	    $reload = 1;
	}
    } elseif (strlen($mv_dir_old) && strlen($mv_dir_new)) {
	if (preg_match("/^\//", $mv_dir_new)) {
	    if ($this_user['usertype'] != "administrator") {
		$error = 5;
	    }
	    $new_abs_cwd = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$mv_dir_new";
	} else {
	    $new_abs_cwd = "$abs_cwd/$mv_dir_new";
	}
	if (!$error) {
	    if (is_dir($new_abs_cwd)) {
		$error = 2;
	    } else {
		$error = recursive_copy("$abs_cwd/$mv_dir_old", $new_abs_cwd);
		if ($error) {
		    system("rm -rf $new_abs_cwd");
		} else {
		    $mv_suc = "Omdbt til <b>$mv_dir</b>";
		    $sys_abs_cwd = check_chrs("$abs_cwd/$mv_dir_old");
		    system("rm -rf $sys_abs_cwd");
		}
	    }
	}
    } elseif (strlen($del_dir)) {
	if (!is_dir("$abs_cwd/$del_dir")) {
	    $error = 6;
	} elseif (!is_empty("$abs_cwd/$del_dir")) {
	    $error = 7;
	} elseif (!rmdir("$abs_cwd/$del_dir")) {
	    $error = 4;
	} else {
	    $del_suc = "Underkatalog <b>$del_dir</b> slettet";
	}
    }
    //header("Location: $admin_script?" . makeparms($context, array("reload"=>$reload, "pop_up_write"=>$pop_up_write, "pop_up"=>$pop_up, "new_suc"=>$new_suc, "mv_suc"=>$mv_suc, "created_dir"=>$new_dir, "del_suc"=>$del_suc, "new_err"=>$new_err, "del_err"=>$del_err, "mv_err"=>$mv_err)));
    header("Location: shell.php?cwd=$cwd&admin=1&error=$error&pop_up_write=$pop_up_write&pop_up=$pop_up");
} elseif ($action == "index") {
    if (!$reindex && !$portal_path) {
	exception("What path?");
    }
    if ($reindex) {
	search_index_all($reindex);
	header("Location: $admin_script?" . makeparms($context, array("reindex"=>$reindex)));
    } elseif ($start_search) {
	search_start($portal_path);
	header("Location: $admin_script?" . makeparms($context, array("start_search"=>$start_search)));
    } elseif ($stop_search) {
	search_stop($portal_path);
	header("Location: $admin_script?" . makeparms($context, array("stop_search"=>$stop_search)));
    } else {
	exception("Don't know what to do!");
    }
} else {
    exception("Unknown type of action '$action'");
}
    


// $Log: handle_call.php,v $
// Revision 1.3  2003/06/10 12:38:11  adam
// Dollar id in headers
//
// Revision 1.2  2003/03/02 11:02:07  sondberg
// Smallies.
//
// Revision 1.1  2003/02/28 14:55:15  sondberg
// Added this file.
//
// Revision 1.21  2003/01/02 14:27:04  sondberg
// Now checking for tainted path user input.
//
// Revision 1.20  2002/12/09 14:11:19  sondberg
// Removing white space in front of and after dir names.
//
// Revision 1.19  2002/09/12 10:08:18  sondberg
// Relative symbolic linking stable with respect to (re)moving of files.
//
// Revision 1.18  2002/07/29 08:30:04  sondberg
// Relative pathes in create link and move file.
//
// Revision 1.17  2002/07/26 08:45:54  sondberg
// Now it is possible to move files.
//
// Revision 1.16  2002/07/25 14:30:57  sondberg
// Prepared for moving files in prop.php.
//
// Revision 1.15  2002/07/25 13:50:14  sondberg
// Various work, and creates links on request.
//
// Revision 1.14  2002/07/18 10:13:30  sondberg
// It is now possible to move directories.
//
// Revision 1.13  2002/07/10 15:39:42  sondberg
// Corrected a bug which prevented one from keeping portal local schemas.
//
// Revision 1.12  2002/07/10 09:55:43  sondberg
// Supports delete records.
//
// Revision 1.11  2002/07/09 07:31:37  sondberg
// Pop-up window with index.tkl for new dirs.
//
// Revision 1.10  2002/07/08 09:36:57  sondberg
// Smallies.
//
// Revision 1.9  2002/07/05 14:18:47  sondberg
// User authentication implemented.
//
// Revision 1.8  2002/07/04 10:24:03  sondberg
// Corrected a bug in the change directory name functions.
//
// Revision 1.7  2002/07/04 09:42:44  sondberg
// Implemented a change dir name function.
//
// Revision 1.6  2002/07/03 15:43:35  sondberg
// Corrected bug in indexing menu.
//
// Revision 1.5  2002/07/03 15:33:49  sondberg
// Corrected a bug.
//
// Revision 1.4  2002/07/03 14:53:21  sondberg
// Added start and stop features.
//
// Revision 1.3  2002/07/03 14:28:46  sondberg
// Added new menu item, the "Indeksering" item.
//
// Revision 1.2  2002/07/03 08:27:40  sondberg
// Now the editor popup works in netscape and IE.
//
// Revision 1.1  2002/07/01 08:37:59  sondberg
// Added this file to repository.
//

?>
